# PIACERE framework
PIACERE aims to increase the productivity of DevOps teams in the development and operation of IaC through the provisioning of an integrated DevSecOps framework. 
DevOps teams can program IaC as if they were programming any software application.

#### Table of Contents
  - [Description](#Description)
  - [Repository structure](#Repository-structure)
  - [Components](#Components)
  - [Contact](#contact)
  - [Acknowledgement](#acknowledgement)

## Description
PIACERE enables the automation of several deployment, configuration and management tasks that otherwise would have to be performed manually by an operator.
PIACERE solution consists of an integrated DevSecOps framework to develop, verify, release, configure, provision, and monitor infrastructure as code. 
The main characteristics of this solution are: 
![VISION](https://piacere-project.eu/wp-content/uploads/2023/05/Vision2.png)

## Repository structure
The Public repository of PIACERE project is organized as follows:
- /agents: contain the monitoring agents that need to be deployed along with the IaC to monitor the infrastructure
- /demos: different demos that can serve as a basic examples of using PIACERE
- /The Platform: is divided in many repositories where the several [components](#Components) of the PIACERE framework can be found

## Contact
**Juncal Alonso**, PIACERE project manager, TECNALIA 
[Juncal.Alonso@Tecnalia.com]

## Components
| Component                             | Repository                                    |
| --------------------------------------|-----------------------------------------------|
| CSE - Canary Sandbox Environment      | [The Platform/cse]                            |
| IOP - IaC Optimized Platform          | [The Platform/iop]                            |
| Runtime Monitoring                    | [The Platform/runtime-monitoring]             |
| Runtime security monitoring           | [The Platform/runtime-security-monitoring]    |
| DOML - DevSecOps Modelling Language   | [The Platform/doml]                           |
| DOML Model Checker                    | [The Platform/doml-model-checker]             |
| IaC Scan Runner                       | [The Platform/iac-scan-runner]                |
| ICG - Infrastucture as Code Generator | [The Platform/icg]                            |
| IDE                                   | [The Platform/ide]                            |
| IEM - IaC Executor Manager            | [The Platform/iem]                            |
| Self-Healing                          | [The Platform/self-healing]                   |
| Self-Learning                         | [The Platform/self-learning]                  |


[The Platform/cse]: https://git.code.tecnalia.com/piacere/public/the-platform/cse
[The Platform/iop]: https://git.code.tecnalia.com/piacere/public/the-platform/iop
[The Platform/runtime-monitoring]: https://git.code.tecnalia.com/piacere/public/the-platform/runtime-monitoring
[The Platform/runtime-security-monitoring]: https://git.code.tecnalia.com/piacere/public/the-platform/runtime-security-monitoring
[The Platform/doml]: https://git.code.tecnalia.com/piacere/public/the-platform/doml
[The Platform/doml-model-checker]: https://git.code.tecnalia.com/piacere/public/the-platform/doml-model-checker
[The Platform/iac-scan-runner]: https://git.code.tecnalia.com/piacere/public/the-platform/iac-scan-runner
[The Platform/icg]: https://git.code.tecnalia.com/piacere/public/the-platform/icg
[The Platform/ide]: https://git.code.tecnalia.com/piacere/public/the-platform/ide
[The Platform/iem]: https://git.code.tecnalia.com/piacere/public/the-platform/iem
[The Platform/self-healing]: https://git.code.tecnalia.com/piacere/public/the-platform/self-healing
[The Platform/self-learning]: https://git.code.tecnalia.com/piacere/public/the-platform/self-learning

[Juncal.Alonso@Tecnalia.com]: mailto:Juncal.Alonso@Tecnalia.com
